#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/mman.h>
#include <termios.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>
#include <signal.h>

#include "pcie40_registers.h"
#include "pcie40_s_pages.h"
#include "altera_dma_cmd.h"
#include "main_pcie40_dmatest.h"
#include "pk_tstlib.h"
//----
#define BUFFER_LENGTH 40

//echo 5120000000 > /proc/sys/kernel/shmmax to trzeba odpalic, by zwiekszyc limit

extern ssize_t f;
char line[BUFFER_LENGTH];
//--------------------------------------------------------------------------------------------
SUB_EVENT ev[4];
//--------------------------------------------------------------------------------------------
int on=1;
void my_handler(int s){
  printf("Caught signal %d\n",s);
  on=0;
}


int main () {
  char cc;
  // unsigned mask=15;
  unsigned mask=1;
  unsigned monprint=100;
  int num_input,i,j,size256, loop,loop_num=1,gen_loop_num,statusik;
  unsigned found;
  unsigned levels=0x0502;
  unsigned ftbsize[4];
  //------------------------

  int *link_data[LINK_NUMBER];
  unsigned *pout,*reinit;

  int *pp;
  int *dpp[LINK_NUMBER][S_PAGES];
  double cumsize256;
  struct timeval t1, t2;
  double elapsedTime,data_volume,trgrate;
  int evgen=0;

  struct sigaction sigIntHandler;
  sigIntHandler.sa_handler = my_handler;
  sigemptyset(&sigIntHandler.sa_mask);
  sigIntHandler.sa_flags = 0;
  sigaction(SIGINT, &sigIntHandler, NULL);

  unsigned  int cpt=0, preCpt=0xFFFFFFFF;
  int  pkLost=0;
  int  pkFoundData=0;
  int  pkFound0=0;
  double frequency;
  //-------------------------
  pid_t pid=getpid();
  //------------------------

  //char *buf = malloc(sizeof(struct dma_status));
  //struct dma_cmd cmd;
  //cmd.usr_buf_size = sizeof(struct dma_status);

  system("clear");

  dev_init();


  int k;
  int  initial_value ;
  for(i=0;i<LINK_NUMBER;i++)
    for(j=0;j<S_PAGES;j++) {
      set_act_spage(i,j); //set spage for mapping;
      dpp[i][j] = (int *) mmap(NULL, S_PAGE_SIZE,  PROT_READ | PROT_WRITE, MAP_SHARED, f, 0);  //map spage
      //   memset( dpp[i][j],0,S_PAGE_SIZE);

      if (dpp[i][j] == MAP_FAILED) {
        printf( "error: mmap: %s\n", strerror(errno));
        exit(EXIT_FAILURE);
      }
    }

  // Protection for the nb event size should never be 0 ( crash)
  initial_value= get_reg_bar2(REG_NB_WORD_IN_EVENT,0);
  if ( ! (initial_value&0xFF) )
   	set_reg_bar2( REG_NB_WORD_IN_EVENT,0,0xFF);
  set_reg_bar2( REG_TRIG_FREE_RESET ,0,0);

  reset();
  set_reg_bar0(DFC_CNTLR_BASE_ADDR,0,0x00); //stop DMA and running (if any)

  do {
    print_menu();
    if (pid == 0) printf(" pid = %d\n",pid);
    read_line(line, BUFFER_LENGTH, stdin);
    num_input = strtol(line, NULL, 10);
    switch (num_input)
      {
      case EXIT:
        break;

        //--------------------------------------------------------------------------------------------------------------------------
      case CMD_START_DMA:
        {
          unsigned dat;
          int ilink,islot,initialized=0;
          unsigned spage,dbA,dbB;

          UAR uar;
	   
          for(i=0;i<LINK_NUMBER;i++)
            for(j=0;j<S_PAGES;j++)
              memset( dpp[i][j],0,S_PAGE_SIZE);

          printf("loop num: %d; events per loop: %d\n",loop_num,S_PAGE_SLOT_NMB);
          reset();

          set_reg_bar0(DMAFIFO_BAR_CONTROLLER_BASE_ADDR,0,0);  //dma readout
          set_reg_bar0(DMAFIFO_BAR_CONTROLLER_BASE_ADDR,1,0);  // size from header

          //
          set_reg_bar0(RST_CNTLR_BASE_ADDR,3,levels); //set b2tt(Arria) busy levels
          //



          printf("\n");
          show_status();
          printf("trg and enter\n");
          cc=getchar();
          //trigger(10000,S_PAGE_SLOT_NMB*loop_num); //command to the FTSW controller in VME
          //      set_reg_bar0(DFC_CNTLR_BASE_ADDR,0,0x81);     //set running and start DMA;
          //data is connected to data_flow_controller
          statusik=0;     cumsize256=0.0;
          gettimeofday(&t1, NULL);
          pkLost=0;
          pkFoundData=0;
          pkFound0=0;
          cpt=0;
          preCpt=-1;
          loop=0;     //in each loop number of events is equal: S_PAGE_SLOT_NMB
          on=1;

          pid=fork();   //split the execution: child process for the DMA control,
          //main process for the DMA buffer->Shared Memory data transfer
          while(on) {

            if(!pid) {  //child process (DMA control)
              if(!initialized) { ioctl(f, ALTERA_IOCX_CLEAR); initialized++; }
              dbA=1;
              while(on) {
                set_reg_bar0(DFC_CNTLR_BASE_ADDR,0,0x81);  // plus de paquets perdu si ici
                ioctl(f, ALTERA_IOCX_RSTART,&uar.arg);
                if(uar.sr.spag_ready) break; //some superpages have been taken; writing is awoken
                else {
                  //Timeout need to reset
                  printf("Timout %d",loop);
                  set_reg_bar0(DFC_CNTLR_BASE_ADDR,0,0x00);
                  reset();
                  ioctl(f, ALTERA_IOCX_CLEAR);
                }
                usleep(50);
                //      if(!(dbA++%50000)) { printf("loop A\n"); print_infifo(20000); show_status(); fflush(stdout);}
                if(!(dbA++%50000)) {

                  printf("loop A\n"); print_infifo(512); show_status(); fflush(stdout);
                }
              }

              ioctl(f, ALTERA_IOCX_RWAIT);     //suspend read loop until spages_free != 0

              if(uar.sr.spag_ready==BREAK) {   //special action to exit from readout
                //      printf("\npid 0 breaking the read loop %d\n",uar.sr.spag_ready);
                break;
              } //
            }        //end of while(on) loop body  of child (pid=0) process

            else {   //body of while(on) loop of main process
              int spag_ready,spage_wp,i;

              ioctl(f, ALTERA_IOCX_WWAIT,&uar.arg);  //wait here for finished read

              if((spag_ready = uar.sr.spag_ready)==BREAK) {statusik=5; break;}; //special action to exit from readout

              spage_wp   = uar.sr.spag_wp;
              statusik=0;
              dbB=1;
              while(on) {  //loopB
	
                for(i=0;i<spag_ready;i++) {                //we need to transfer all acquired spages  to the shared memory

                  spage=(spage_wp+i)%S_PAGES;
                  //      printf(" spage %d \n",spage);
                  for(islot=0;islot < S_PAGE_SLOT_NMB;islot++) {
                    for(ilink=0;ilink<LINK_NUMBER;ilink++) {

                      pp=dpp[ilink][spage]+islot*S_PAGE_SLOT_SIZE_L;

                      //pk_printA(pp,128);
                      link_data[ilink]=pp;                  //and store it in array
                      if(mask & (1<<ilink)) cumsize256+=((pp[2]>>16) & 0xFFFF);   //accumulate data size
                      //              if ( (( ilink == 0 ) && (islot==0))) printf(" prepmier header %08x %08x %08x %08x %08x\n",pp[0],pp[1],pp[2],pp[3],pp[4]);
                    }//ilink
                    int nb_data;
                    cpt=( pp[4]);

                    if (cpt !=(preCpt+1) ){
                      if (cpt == 3722304989 ) pkFoundData++; //des fois sur la data
                      if (cpt == 0)  pkFound0++; // des fois sur le trailler
                      if ( (cpt != 3722304989 ) && (cpt!= 0)) {
                        if ( (cpt - preCpt) >0 ) {
                          pkLost=pkLost + (cpt-preCpt);
                          // printf("slot courant  header %08x %08x %08x %08x %08x\n",pp[0],pp[1],pp[2],pp[3],pp[4]);
                          on=0;  // Monique on arrete la car plein de paquets seront perdus à enlever si l'on veux continuer
                        }
                        printf("loop %d slot %d lost %X != %X\n",loop ,islot, cpt,preCpt);
                      }
                    }
                    if (( cpt >= 0 )&&(cpt != 0xDDDDDDDD )) preCpt=cpt;

                    //  if ( !  (cpt % (16*128)))  usleep(5000); // pour bloquer la lecture

                    // Do something with the datas here
                    SendDatas( pp, (pp[2]>>16)&0xFFFF);
                  }//islot
                  loop++;

                }//i (spage)
	
                uar.sr.spag_ready=i; //only spages whichave been sucessfuly sent are considered
                if(i)  break;        //something was sent to the shared memory
                usleep(50);              // nothing was sent

              }//while on; end of loopB

              if( loop >=loop_num) {
                uar.sr.spag_ready=BREAK;
                ioctl(f, ALTERA_IOCX_RCONT,uar.arg);
                break;   //enough events taken
              }

              ioctl(f, ALTERA_IOCX_RCONT,uar.arg);  // sending info (number of sent spages=number of free spages)
              // to read loop (pid 0)

              if(!(loop%monprint))  {printf("\r--> %d",loop);  fflush(stdout);}
            } //end of main process loop body
          }//while on

          if(!pid) {                                 //exiting pid 0 process
            ioctl(f, ALTERA_IOCX_CLEAR);
            //?clean(PP,dpp);
            printf("\nexit DMA Loop\n");
            exit(0); }


          gettimeofday(&t2, NULL);
          elapsedTime = (t2.tv_sec+t2.tv_usec/1.e6 - t1.tv_sec-t1.tv_usec/1.e6);

          trgrate=(loop*S_PAGE_SLOT_NMB)/elapsedTime;
          printf("\nout of loop; %ld events\n",loop*S_PAGE_SLOT_NMB);
          printf("vol.:%6.3fMB time:%6.3fs speed:%4.1fMB/s trigger rate: %.1f\n",(cumsize256)/1000000.,elapsedTime,((cumsize256)/1.e6)/elapsedTime,trgrate);
          printf("average ev. size:%4.0fB\n",(cumsize256)/(loop*S_PAGE_SLOT_NMB));
          if(statusik) printf(" statusik: %d, found: %x\n",statusik,found);
          printf("\nFrequency générator %.1f \n",frequency);
          if (pkLost) printf("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
          printf (" nb event lost calculated %d , diff first lastcounter %d  nb loop  %ld cpt %ld  pkFoundData %d pkFound0 %d \n",pkLost,(cpt+1)-(( loop*S_PAGE_SLOT_NMB )) ,loop,cpt,pkFoundData,pkFound0);
          preCpt=-1; // we stop the loop so for the next should be 0 the Cpt is clear
          set_reg_bar0(DFC_CNTLR_BASE_ADDR,0,0); //clear DMA and running
          printf(" Last Cpt in header event ( %X)= %ld = %ld  \n",pp[4],pp[4],cpt);

          cc=getchar();
        }//block
        break;
        //--------------------------------------------------------------------------------------------------------------------------
      case MODIFY_LINK_MASK:                     //mask operation is not verified (Feb.2020)
        {
          printf("link mask: ");
          read_line(line, BUFFER_LENGTH, stdin);
          mask = strtol(line, NULL, 10);
          modify_link_mask(mask);
        }
        break;
      case CMD_READ_STATUS:                //
        {
          show_status();
          cc=getchar();
          break;
        }
      case      GET_REG_BAR0:                            //read BAR0 register
        {
          unsigned base,off,nmb,i=0;
          while(i!=3) {
            printf("base32 offset32 (hex)  nmb (dec)\n");
            read_line(line, BUFFER_LENGTH, stdin);
            i=sscanf(line,"%x %x %d", &base,&off,&nmb);
          }
          for(i=0;i<nmb;i++)  printf("%x   %x  ----> %x\n",off+i, (off+i)*4, get_reg_bar0(base,(off+i)));
          cc=getchar();
          break;
        }

      case      SET_REG_BAR0:                         //write to the BAR0 register
        {
          unsigned base,off,val,i=0;
          while(i!=3) {
            printf("base offset32 (hex)  val (hex)\n");
            read_line(line, BUFFER_LENGTH, stdin);
            i=sscanf(line,"%x %x %x",&base, &off,&val);
          }
          set_reg_bar0(base,off,val);
          break;
        }

      case DEBUG_0:
        {
          print_infifo(20000);
          cc=getchar();
          break;
        }
      case READ_CMD1_REG:
        read_registers();
        break;


      case SET_DMA_WORDS:
        set_dma_word();
        break;

      case SET_NB_EVENT:
	set_nb_event();
	break;
      case ENABLE_FREE:
        enable_free();
	  break;
	
      case DISABLE_TEST_DATA:
	  disable_test_data();
	  break;
      case ENABLE_TEST_DATA:
	enable_test_data();
	break;

      case DISABLE_FREE:
	disable_free();
	break;

      case SET_TRIGGER_FREQUENCY:
	frequency= set_trigger_frequency();
	break;

      case DUMP_STATE: // FIFO latency
	dump_fifo_latency();
        break;
      case SELECT_DATA_FROM_FIBER:
	data_from_fiber();
        break;
      case SELECT_DATA_FROM_GENE :
	data_from_generator();
        break;
      case CLEAN:
        {
          printf("cleaning\n");
          reset();
          usleep(10000);
          break;
        }


      case LOOP_NUMBER:
        printf("enter loop num: ");
        read_line(line, BUFFER_LENGTH, stdin);
        loop_num = strtol(line, NULL, 10);
        gen_loop_num = loop_num*LINK_NUMBER*S_PAGE_SLOT_NMB; //one loop corresponds to S_PAGE_SLOT_NMB events
        //each event comprises 4 (LINK_NUMBER) subevents
        break;
      case 99 :
        {
          printf("dump the HEADER( 8 word) of each SPAGES\n");
          int *pd;
          int nb_data;
          int i,j;
          for(i=0;i<LINK_NUMBER;i++)
            for(j=0;j<S_PAGES;j++) {
              pd= dpp[i][j];
              printf(" SPAGE %02d :",j);
              for ( nb_data=0; nb_data < 8 ; nb_data++) printf("  %X ",*pd++);
              printf("\n");
            }
	  printf (" last ist %d \n", get_reg_bar0(	DFC_SPAGE_ACK_BASE_ADDR,0));
          cc=getchar();
          break;
        }
      default:
        printf("%d is an invalid command\n", num_input);
      }
    system("clear");
  } while (num_input != EXIT);




}
//---------------------------------------------------------------------------------------------------



